package uloha1;

import java.io.File;
import java.io.IOException;
import java.net.URL;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;


/*************************************************************************
 *  Tento kod tridy vezmete, doplnte tela metod <code>adjustSalary</code>,
 *  <code>changeName</code> a <code>getWageCosts</code>.
 *  S ostatnimi nedelejte nic.
 *  Po doplneni by mela fungovat metoda <code>main</code> tak, jak je.
 *  Pro preklad a spusteni muzete vyuzit skript build.xml.
 */
public class Uloha1 {
    
    /**
     * W3C object model representation of a xml document.
     * Note: We use the interface(!) not its implementation
     */
    private Document doc;
    
    
    /*************************************************************************
     * Metoda na upravu platu.
     * Ma-li osoba mensi plat nez <code>minimum</code>,
     * bude ji plat zvysen na <code>minimum</code>.
     * S ostatnimi osobami se nic nedeje.
     */
    public void adjustSalary(double minimum) {
        // sem doplnte kod metody (misto uvedene vyjimky)
        throw new UnsupportedOperationException();
    }
    
    /*************************************************************************
     * Metoda na zmenu jmena.
     * U osoby s danym <code>id</code> se zmeni jmeno na <code>newName</code>.
     * S ostatnimi osobami se nic nedeje.
     */
    public void changeName(String id, String newName) {
        // sem doplnte kod metody (misto uvedene vyjimky)
        throw new UnsupportedOperationException();
    }
    
    /*************************************************************************
     * Metoda na spocitani mzdovych nakladu.
     * Metoda projde vsechny osoby ve vstupnim souboru a secte hodnoty jejich
     * platu.
     */
    public double getWageCosts() {
        // sem doplnte kod metody (misto uvedene vyjimky)
        throw new UnsupportedOperationException();
    }
    
    /*************************************************************************/

    /**
     * Vytvori novou instanci teto tridy a nacte obsah
     * xml dokumentu se zadanym URL.
     */
    public static Uloha1 newInstance(URL url) throws SAXException, 
            ParserConfigurationException, IOException {
        return new Uloha1(url);
    }
    
    /**
     * Vytvori novou instanci teto tridy a nacte obsah
     * xml dokumentu ze zadaneho souboru.
     */
    public static Uloha1 newInstance(File file)
    throws SAXException, ParserConfigurationException, IOException {
        return newInstance(file.toURL());
    }
    
    /**
     * Konstruktor, ktery vytvori novou instanci tridy Uloha1
     * nactenim obsahu xml dokumentu se zadanym URL.
     */
    private Uloha1(URL url) throws SAXException, ParserConfigurationException,
            IOException {
        // Vytvorime instanci tovarni tridy
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        // Pomoci tovarni tridy ziskame instanci DocumentBuilderu
        DocumentBuilder builder = factory.newDocumentBuilder();
        // DocumentBuilder pouzijeme pro zpracovani XML dokumentu
        // a ziskame model dokumentu ve formatu W3C DOM
        doc = builder.parse(url.toString());        
    }
    
    public void serializetoXML(URL output)
    throws IOException, TransformerConfigurationException, TransformerException {
        // Vytvorime instanci tovarni tridy
        TransformerFactory factory = TransformerFactory.newInstance();
        // Pomoci tovarni tridy ziskame instanci tzv. kopirovaciho transformeru
        Transformer transformer = factory.newTransformer();
        // Vstupem transformace bude dokument v pameti
        DOMSource source = new DOMSource(doc);
        // Vystupem transformace bude vystupni soubor
        StreamResult result = new StreamResult(output.toString());
        // Provedeme transformaci
        transformer.transform(source,result);
    }

    public void serializetoXML(File output) throws IOException,
            TransformerException {
        serializetoXML(output.toURL());
    }
    
    public static void main(String[] args) throws IOException, SAXException, ParserConfigurationException, TransformerException {
        
        if (args.length < 1) {
            System.err.println("Chybi argument se jmenem souboru pro " +
                    "zpracovani!");
            return;
        } else if (args.length < 2) {
            System.err.println("Chybi argument se jmenem vystupniho souboru!");
            return;
        }
        
        File input = new File(args[0]);
        File output = new File(args[1]);
        
        Uloha1 uloha1 = newInstance(input);
        
        System.out.println(uloha1.getWageCosts());
        
        uloha1.changeName("1", "Pavl\u00edk");
        uloha1.changeName("2", "Liborek");
        uloha1.adjustSalary(10000f);
        
        System.out.println(uloha1.getWageCosts());
        
        uloha1.serializetoXML(output);
    }
    
    /**
     * Help method for testing purposes.
     */
    Document getDocument() {
        return doc;
    }
}

